/*  File:     feld.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctGame
    Autor:    
    Descript: Das Spielfeld
              Diese Klasse representiert ein "intelligentes" Spielfeld
    last mod: Mon Apr 30 23:28:27 CEST 2001
*/

package cnctGame;
import point;

public class feld
{
    //member 
    private  byte spielfeld[][]; 
    private  int hoehe;
    private  int breite;

    //konstanten
    public final byte EMPTYFELD= 0;     //leeres Feld    
    public final byte BLACKNOSET=  1;   //Schwarz kann nicht setzen
    public final byte BLACK_IS_SET=4;   //Schwarz hat gesetzt
    public final byte WHITENOSET=  2;   //Weiss kann nicht setzen
    public final byte WHITE_IS_SET=8;   //Weiss hat gesetzt
    
//    public final byte LAST_WHITE_SET=
//    public final byte LAST_BLACK_SET=
    public final byte NOSET=WHITENOSET | BLACKNOSET;//niemand kann setzen

  //////////////////////////// D E K L A R A T I O N /////////////////////////
	//###Konstruktor
	// public feld(int size);
	//###Feldpunkt wird auf Farbe gesetzt (0-Schwarz;1-Weiss) 
	// public boolean setposition(point fpoint, int color);
	//###position von fpoint auslesen Fehler=-1
	// public boolean getValid(point fpoint, int color);
	// public byte getposition(int x, int y);	
	// public byte getposition(point fpoint);
	//###gibt hoehe zurueck
	// public int getHeight();
	//###gibt breite zurueck
	// public int getWidth();
	// public void printout();
  

  //////////////////////////// I M P L E M E T I E R U N G /////////////////////////////
  //Konstruktor
  //-----------------------------------------------
  public feld(int size)
  {
    breite=hoehe=size;
    
      spielfeld=new byte[breite][hoehe];
      for(int i=0;i<breite;i++)
        for(int j=0;j<hoehe;j++){       
          spielfeld[i][j]=0;
          if (i%2!=0){if (j%2==0) spielfeld[i][j]|=NOSET;}
            else if (j%2!=0) spielfeld[i][j]|=NOSET;
        }

      //Randfelder nicht schwarz
      for(int i=0;i<breite;i++){
        spielfeld[0][i]|=BLACKNOSET;
        spielfeld[breite-1][i]|=BLACKNOSET;
      }

      //Randfelder nicht weiss
      for(int i=0;i<hoehe;i++){
        spielfeld[i][0]|=WHITENOSET;
        spielfeld[i][hoehe-1]|=WHITENOSET;      
      }
  }

    //Feldpunkt wird auf Farbe gesetzt (0-Schwarz;1-Weiss) 
    //-----------------------------------------------
    public boolean setposition(point fpoint, int color)
    {
        if(fpoint.x<1 || fpoint.x>breite || fpoint.y<1 || fpoint.y>hoehe)
          return false;
	if (!getValid(fpoint,color))
	  return false;
	  
        if (color==0){ 
          if ((spielfeld[fpoint.x-1][fpoint.y-1] & BLACKNOSET)==0) { 
              spielfeld[fpoint.x-1][fpoint.y-1] = (byte)(spielfeld[fpoint.x-1][fpoint.y-1] | WHITENOSET | BLACK_IS_SET | BLACKNOSET); 
              return true;
           }
        }else if (color==1){ 
          if ((spielfeld[fpoint.x-1][fpoint.y-1] & WHITENOSET)==0) {
             spielfeld[fpoint.x-1][fpoint.y-1] = (byte)(spielfeld[fpoint.x-1][fpoint.y-1] | BLACKNOSET | WHITE_IS_SET | WHITENOSET);
             return true;
           }
        }
      return false;
    }

    //position von fpoint auslesen
    //-----------------------------------------------    
    public boolean getValid(point fpoint, int color)
    {
      // Bereichsueberpruefung
      if(fpoint.x<1 || fpoint.x>breite || fpoint.y<1 || fpoint.y>hoehe) return false;
      if(color==0) return((spielfeld[fpoint.x-1][fpoint.y-1] & BLACKNOSET)==0); 
      if(color==1) return((spielfeld[fpoint.x-1][fpoint.y-1] & WHITENOSET)==0);
      ///keine korrekte farbe
      return false;      
    }
    	
    //-----------------------------------------------
    public byte getposition(int x, int y)
    {
       return getposition(new point(x,y));
    }
    //-----------------------------------------------    
    public byte getposition(point fpoint)
    {
       if(fpoint.x<1 || fpoint.x>breite || fpoint.y<1 || fpoint.y>hoehe) return NOSET;
       return(spielfeld[fpoint.x-1][fpoint.y-1]);
    }
    

  

	//gibt hoehe zurueck
	//-----------------------------------------------
	public int getHeight()
	{
		return hoehe;
	}

	//gibt breite zurueck
	//-----------------------------------------------	
	public int getWidth()
	{
		return breite;
	}

    // gibt Feld auf der Konsole aus
    //-----------------------------------------------
    public void printout(){
       byte field;
       for(int i=0;i<11;i++){
         for(int j=0;j<11;j++){
          field=getposition(j,i);
          if (field==EMPTYFELD){System.out.print(".");}
          if (field==BLACKNOSET){System.out.print("W");}
          if (field==WHITENOSET){System.out.print("S");}
          if (field==NOSET){System.out.print("+");}
          if ( (field & BLACK_IS_SET) !=0 ){System.out.print("s");}
          if ( (field & WHITE_IS_SET) !=0 ){System.out.print("w");}
	 }
	 System.out.println();
	}    
      }
}
