/*  File:     cnctInfoClient.java 
    Project:  OOPracktikum 2001
	            Connect-Game Info Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Descript: Connect-Infoclient tum Aushandeln von Spielen
              Diese Klasse bildet die Applikation 
    last mod: Mon Apr 30 23:28:27 CEST 2001   
*/
import java.awt.Frame;
import java.awt.event.*;
import java.awt.*;
import java.io.IOException;


import cnctInfoClientApplet;
import cnctInfoConfig.*;
import cnctInfoClientPack.*;
import cnctClient;
import cnctClientCallerInterface;


public class cnctInfoClient  extends Frame implements ActionListener,  cnctClientCallerInterface
{

    private cnctInfoClientApplet parent;
    private cnctInfoPanel panel;
    private cnctClient internclient; 
    private String playername;
    private String host;
    private int port;
    private cnctStart config;
    private int clientNumber; //-1 fr keinen Client 0 fuer intern und alles weitere entspricht dann den Client in der Datei
    
    /*Menu*/
    private MenuBar menubar=new MenuBar();
    private Menu file=new Menu("File");
    private Menu game=new Menu("Game");
    private Menu options=new Menu("Options");
    private Menu infos=new Menu("?");
    private MenuItem exititem=new MenuItem("Exit");
    private MenuItem newitem=new MenuItem("New");
    private MenuItem joinitem=new MenuItem("Join");
    private MenuItem watchitem=new MenuItem("Watch");
    private MenuItem refreshitem=new MenuItem("Refresh");
    private MenuItem aboutitem=new MenuItem("About");


    //------------------------------------------------
    public cnctInfoClient(cnctInfoClientApplet _parent, String _host, int _port){


	parent=_parent;
	host=_host;
	port=_port;
	clientNumber=0;  // internen Client benutzten

	//Konfiguration Laden (nur bei Application)
	config=new cnctStart();
	if(parent==null){
	    if(!config.loadInfoConfig("info.conf")){
		System.out.println("Fehler beim laden der Konfigurationsdatei: info.conf");
	    };
	}
 
	setSize(640,480);
	cnctInfoNameDlg namedlg=new cnctInfoNameDlg(this,"Playername",config.getClients());
	namedlg.setLocation(200,200);
	namedlg.setSize(400,200);
	namedlg.setVisible(true);
	namedlg.toFront();

    }
    
    //------------------------------------------------
    public void setClientNumber(int number){
	clientNumber=number;
    }
    
    //------------------------------------------------
    public void startClient(){
  	  if(clientNumber==0){
        internclient = new cnctClient(this,host,port+1,playername);
        internclient.show();
      }else
      if(clientNumber>=1){
	      config.executeClient(clientNumber, playername);
	  }
    }
    
    //------------------------------------------------
    public void closeclient(){
      if(internclient!=null){
        internclient.dispose();
      }
    }
  

    //------------------------------------------------
    public void initPanel(){

	point size = new point(640,480);
	setTitle("Connect-Info-Client-0.0.1");
	setLocation(100,100);	    
	setSize(size.x,size.y);
  
	panel=new cnctInfoPanel(this, size, host, port, playername);
	add(panel);
      
	System.out.println("Client: Num: "+ clientNumber + " wurde gewhlt");

	/*Menu*/
	setMenuBar(menubar);
	menubar.add(file);
	menubar.add(game);
	menubar.add(options);
	menubar.add(infos);
	file.add(exititem);
	game.add(newitem);
	game.add(joinitem);
	game.add(watchitem);
	options.add(refreshitem);
	infos.add(aboutitem);
		
	joinitem.setEnabled(false);
	watchitem.setEnabled(false);
		


	/*Actions*/
	file.addActionListener(this);
	game.addActionListener(this);
	options.addActionListener(this);
	infos.addActionListener(this);
	exititem.setActionCommand("EXIT");
	newitem.setActionCommand("NEW");
	joinitem.setActionCommand("JOIN");
	watchitem.setActionCommand("WATCH");
	refreshitem.setActionCommand("REFRESH");
	aboutitem.setActionCommand("ABOUT");
		
	// Event einbauen fr Fenster schliessen
	addWindowListener(new WindowAdapter(){
	        public void windowClosing(WindowEvent e){
	          close();
		  }
	    }
			  );
        
        /// uns selber anzeigen
        show();  
    }


    public void close(){
      	    if(panel !=null) panel.close();
		    if(parent == null){
			  System.exit(0);
		    }else{
			  parent.destroy();
		    }
    }
  
    //--------------------------------------------------------
    public void actionPerformed(ActionEvent e){
	String command=new String(e.getActionCommand()); 
	//EXIT 
	if (command.compareTo("EXIT")==0){
          close();
	}else if	(command.compareTo("NEW")==0){		//NEW
	    panel.newgame();
	}else	if	(command.compareTo("JOIN")==0){		//JOIN
	    panel.joingame();
	}else	if	(command.compareTo("WATCH")==0){		//WATCH
	    panel.watchgame();
	}else	if	(command.compareTo("REFRESH")==0){	//REFRESH
	    panel.refresh();
	}else	if	(command.compareTo("ABOUT")==0){		//ABOUT
	    aboutdialog();
	}		

    }

    private void aboutdialog()
    {
	/*		///!!!
			Dialog aboutdlg=new Dialog(this,"About");
			aboutdlg.setSize(200,200);
		
			aboutdlg.show();*/
    }


    public void grayControl(int status)
    {
	switch (status){
	case 1: 
	    joinitem.setEnabled(false);
	    watchitem.setEnabled(false);
	    break;
	case 2: 
	    joinitem.setEnabled(true);
	    watchitem.setEnabled(true);
	    break;
	case 3: 
	    joinitem.setEnabled(false);
	    watchitem.setEnabled(true);
	    break; 
	case 4: 
	    joinitem.setEnabled(false);
	    watchitem.setEnabled(false);
	    break;
	}	
    }
	
    public void setPlayerName(String name)
    {
	playername=name;
    }

    public void startNewGame(int gamesize,int gamecolor)	
    {
	panel.startNewGame(gamesize,gamecolor);
    }

    //--------------------------------------------------------

    // MAIN
    public static void main(String[] args)
    {
	String host=new String("theopc.informatik.uni-leipzig.de");
	int port=9000;
	if(args.length>1){
	    Integer tempport;
	    host = new String(args[0]);
	    tempport=new Integer(args[1]);
	    port=tempport.intValue();
	}else{
	    System.out.println("Usage: java cnctClient {host port}");
	    System.out.println("I use host: "+host + " port: "+ port);
	}     
      
	cnctInfoClient mainapp = new cnctInfoClient(null,host, port);
    }

  
}













