/*  File:     cnctInfoPanel.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Descript: Anzeige das Connect Info-Client 
              uebernimmt Grafische Ausgabe und den Socket Betrieb
    last mod: Mon Apr 30 23:28:27 CEST 2001            
*/
package cnctInfoClientPack;

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;

import point;
import cnctInfoClient;
import cnctInfoSocket.*;
import cnctInfoConfig.*;

public class cnctInfoPanel extends Panel implements cnctInfoSocketEvent, ActionListener
{ 
//Member
private cnctInfoClient parent;
private  cnctInfoSocketClient socket;
private int akttablenumber;
private cnctInfoPlayerList cnctplayer;
private cnctInfoGameList cncttables;

private String playername;


/*Layout*/
private GridBagLayout gbl;
private GridBagConstraints gbc;

/*Elemente*/
private Label headline;
private List tablelist=new List();
private List playerlist=new List();
private List tableplayer=new List();
private Label statusline=new Label("Anweisungen");
private Button newbutton=new Button("New");
private Button joinbutton=new Button("Join");
private Button watchbutton=new Button("Watch");
private Button refreshbutton=new Button("Refresh");

///!!!ins Feld
public static final int BLACK=0;
public static final int WHITE=1;

   /////////////////////////////////////D E K L A R A T I O N E N/////////////////////
   // public void close()
   
   //public void setPlayerName(String name);

    //######## P R I V A T E ####



  ///////////////////////////////////// D E F I N I T I O N E N /////////////////////
  // bekommt Groesse des Clientfensters
   public cnctInfoPanel(cnctInfoClient _parent, point _size, String host, int port, String _playname){

		playername=_playname;
		headline=new Label("Name: " + playername);
	        parent=_parent;

		/*Schrift setzen*/
	//	setFont(new Font("Helvetica",Font.PLAIN,14));
		
		/*Layout setzen*/
		componentInit();	
   	
		/*Actionlistener setzen*/
		newbutton.addActionListener(this);		
		joinbutton.addActionListener(this);		
		watchbutton.addActionListener(this);		
		refreshbutton.addActionListener(this);				
		playerlist.addActionListener(this);
		tablelist.addActionListener(this);
		
		
		joinbutton.setEnabled(false);
		watchbutton.setEnabled(false);
		tableplayer.add("Bitte einen Doppelklick auf einen Eintrag");
		tableplayer.add("in einen der beiden Listen durchfhren.");
		tableplayer.add("Die Buttons um untern Rand werden");
		tableplayer.add("dann abhngig von Ihrer Auswahl aktiviert.");
		
		/// SOCKET
      try{
         socket = new cnctInfoSocketClient(this, host, port);
         socket.start();
         socket.login(playername);
	   }catch(cnctSocketException e){
	     e.printStackTrace(System.out);
	   }
       
   }

   public void close(){
     if (socket != null){
        socket.logout();
        socket.close();       
     }
   }
   

    //public void setPlayerName(String name);

   //overloaded from awt.Container
   //-------------------------------------------------------------------------------------
   public void paint(Graphics g){
   }

  ///////// SOCKETEVENTS  
  //---------------------------------------------------------------------------------------
   public void okReceived(){
      if(socket.getWhatISend()==socket.LOGIN){
        refresh();
      }
   }

   public void errorReceived(){
      if(socket.getWhatISend()==socket.LOGIN){
        System.out.println("Dein Name ist schon vergeben!");
        parent.close();                
      }
   }


  //---------------------------------------------------------------------------------------
   public void players(cnctInfoPlayerList playerList){
     cnctInfoPlayer player;	
	  int size;
	  int i;
	     /*werte uebernehmen*/
		  cnctplayer=playerList;
		  playerlist.removeAll();
		  System.out.println("players:");
    		  playerList.printPlayer();
	   	  size=playerList.size();

		  for(i=0;i<size;i++){
			  player=(cnctInfoPlayer)playerList.elementAt(i);
			  addPlayerToList(player);
		  }
	}

   public void games(cnctInfoGameList gameList){
      cnctInfoGame game;	
	  int size;
	  int i;
	     /*werte uebernehmen*/
		  cncttables=gameList;
		  tablelist.removeAll();
		  System.out.println("Games:");
    		  gameList.printGames();
	   	  size=gameList.size();

		  for(i=0;i<size;i++){
			  game=(cnctInfoGame)gameList.elementAt(i);
			  addTableToList(game);
		  }
   
   }
 
   private void addPlayerToList(cnctInfoPlayer player){
     String content;
     int length;
     int i;
     content =player.getName();
     length=content.length();
     for(i=0;i<25-length;i++){
       content=content + " ";
     }
     content=content + player.getStatusString();
     length=content.length();
     for(i=0;i<40-length;i++){
       content=content + " ";
     }
    content=content + player.getGameNumber();
     
     playerlist.add(content);
   }

    private void addTableToList(cnctInfoGame game){
     String content;
     int length;
     int i;
     content =  new String(game.getGameNumber()+" ");
     length=content.length();
     for(i=0;i<8-length;i++){
       content=content + " ";
     }
     content=content + game.getStatusString();
     length=content.length();
     for(i=0;i<40-length;i++){
       content=content + " ";
     }
    content=content + game.getWinnerString();
     
     tablelist.add(content);
   }
   
  ///////// ACTIONEVENTS  
  //---------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e)
	{
		Object source=e.getSource();

		if (source==newbutton){
			newgame();
		}else if(source==joinbutton){
			joingame();
		}else if(source==watchbutton){
			watchgame();
		}else if(source==refreshbutton){
			refresh();
		}else if(source==playerlist){
				tablelist.deselect(tablelist.getSelectedIndex());
				newplayerselected();
		}else if(source==tablelist){
				playerlist.deselect(playerlist.getSelectedIndex());
				newtableselected();
		}
	}


  ///////// COMPONENTEN  
  //---------------------------------------------------------------------------------------
	private void componentInit()
	{
		/*Layout setzen*/
		gbl = new GridBagLayout();
		gbc = new GridBagConstraints();

		/*Layout setzen*/
		setLayout(gbl);
		gbc.fill = GridBagConstraints.BOTH;
		
		/*Komponenten initialisieren*/		
		gbc.weightx = 1.0;
   	gbc.gridwidth =GridBagConstraints.REMAINDER;
		/*Headline*/
		gbl.setConstraints(headline,gbc);
		add(headline);
	
   	/*Tablelist*/
		gbc.gridwidth=2;
		gbc.gridheight=5;
   	gbc.weighty =1.0;
		add(tablelist);
		gbl.setConstraints(tablelist,gbc);
		
   	/*Playerlist*/
		gbc.gridwidth =GridBagConstraints.REMAINDER;
		add(playerlist);
		gbl.setConstraints(playerlist,gbc);

	   /*Statusline*/
		gbc.weighty =0.0;
		gbl.setConstraints(statusline,gbc);
		add(statusline);

   	/*tableplayer*/
		gbc.weighty =0.75;
   	gbc.gridheight =2;
		add(tableplayer);
		gbl.setConstraints(tableplayer,gbc);

   	/*New-Button*/
		gbc.gridheight =1;
   	gbc.weighty =0.0;
   	gbc.gridwidth=1;
 		gbl.setConstraints(newbutton,gbc);
		add(newbutton);

		/*Joinbutton*/
		gbl.setConstraints(joinbutton,gbc);
		add(joinbutton);

		/*Watchbutton*/
		gbl.setConstraints(watchbutton,gbc);
		add(watchbutton);
   
		/*Refreshbutton*/
		gbl.setConstraints(refreshbutton,gbc);
		add(refreshbutton);
	}

  ///////// COMPONENTEVENTSREACTIONS
  //---------------------------------------------------------------------------------------
	public void newgame(){
		cnctInfoNewDlg dialog = new cnctInfoNewDlg((cnctInfoClient)getParent(),"Start-Optionen"); 
			dialog.setLocation(200,200);
			dialog.setSize(500,100);
			dialog.setVisible(true);
    		dialog.toFront(); 
	}

	public void startNewGame(int _gamesize, int _gamecolor)
	{
		System.out.println(_gamesize);
		System.out.println(_gamecolor);
		socket.newGame(_gamesize,_gamecolor);
    parent.startClient();
  }

	public void joingame(){
		
		socket.join(akttablenumber);
    parent.startClient();
	}

	public void watchgame(){
		socket.watch(akttablenumber);
    parent.startClient();
	}

	public void refresh(){
		socket.who();
		System.out.println("test");
/*		newplayerselected();*/
	}


	private void newplayerselected(){
	    int index=playerlist.getSelectedIndex();
		if(index>=0){
		    cnctInfoPlayer player=(cnctInfoPlayer)cnctplayer.elementAt(index);
		    akttablenumber=player.getGameNumber();
		    grayControl(player.getStatus());
		}else{
		   grayControl(cnctInfoPlayer.IDLE);
		}
	}
	
	private void newtableselected(){
	    int index=tablelist.getSelectedIndex();
		if(index>=0){
		    cnctInfoGame game=(cnctInfoGame)cncttables.elementAt(index);
		    akttablenumber=game.getGameNumber();
		    grayControl(game.getStatus());
		}else{
		   grayControl(cnctInfoGame.DONE);
		}	
	}

	private void grayControl(int status)
	{
		cnctInfoClient client=(cnctInfoClient)getParent();
		switch (status){
		 case 1: 
			joinbutton.setEnabled(false);
			watchbutton.setEnabled(false);
			break;
		 case 2: 
			joinbutton.setEnabled(true);
			watchbutton.setEnabled(true);
		 	break;
		 case 3: 
			joinbutton.setEnabled(false);
			watchbutton.setEnabled(true);
		 	break; 
		 case 4: 
			joinbutton.setEnabled(false);
			watchbutton.setEnabled(false);
		 	break;
		}	
		client.grayControl(status);
	}
	


}
