/*  File:     cnctClient.java 
    Project:  OOPracktikum 2001
	            Connect-Game Info Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoConfig
    Autor:    Georg Martius
    Descript: Representiert Daten eines Spiel-Clients
		
	create:
	date
	Mon Jun  6 16:08:31 MET DST 2001
		
    last mod: 
	date 
    Tue Jun  5 22:45:14 MEST 2001
*/

package cnctInfoConfig;

import cnctParser.*;
import java.io.IOException;
import java.io.*;

public class cnctClient extends Object {
  private String binaryName;
  private int typ;
  private boolean isinit;
  private String name;
  private ReadStreamThread readthread;
  
  
  public final static int HUMAN=1;
  public final static int COMPUTER=2; 

  public cnctClient(){
    typ=0;
    isinit=false;
  }
  
  boolean extractData(knoten baum){
    knoten subknoten;
    int i;
    String variable, value;
    
    if (baum.getTyp() ==  knoten.RECORD){
      for(i=0;i<baum.getKinderZahl(); i++){
        if( (subknoten=baum.getKind(i))==null) continue;;
        if(subknoten.compareName("Bin")){
          binaryName=subknoten.getKind(0).getName();
        }else 
        if(subknoten.compareName("Typ")){
          value=subknoten.getKind(0).getName();
          if(value==null) continue;
          if(value.equalsIgnoreCase("Human")){
            typ=cnctClient.HUMAN;
          }else
          if(value.equalsIgnoreCase ("Computer")){
            typ=cnctClient.COMPUTER;            
          }   
        }else
		if(subknoten.compareName("Name")){
          name=subknoten.getKind(0).getName();
        };   

      }  
    
    }else return false;
    
    isinit=true;
    return true;
  }
  

  public String getName(){
    if(name==null) 
	  if(binaryName!=null) return binaryName;
	  else	return new String("unbekannt"); 
    return name;
  }

  public boolean execute(String host, int port, String name){
    Process proc;
    InputStream istream;
  
    if(!isinit) return false;    
    if(binaryName==null || binaryName.length()==0) return false;
    try{
      System.out.println("Exec: " + binaryName +" " + host +" " +  port+ " " + name);
      proc = Runtime.getRuntime().exec(binaryName +" " + host +" " +  port+ " " + name);
      
    }catch(SecurityException e){
      e.printStackTrace(System.out);
      return false;
    }catch(IOException e){ 
      e.printStackTrace(System.out);
      return false;
    }
    
    readthread=new ReadStreamThread(proc,"test");
    readthread.run();
    
    return true;
  }
  
}


class ReadStreamThread extends Thread {  
      Process process;
      String clientName;
      boolean shouldclose;
      
      ReadStreamThread(Process _process, String _clientName) {
        process=_process;
        clientName=_clientName;
        shouldclose=false;
      }         
      
      public void close(){
        shouldclose=true;
      }
      
      private void printBuffer(PrintStream stream, String buffer){
	 stream.println(clientName + ": " + buffer);
      }
      
      public void run() {
        byte[] buffer=new byte[1000];
        int retval;
        InputStream proc_stdout;
        InputStream proc_stderr;
        
        try{
          proc_stderr=process.getErrorStream();
          proc_stdout=process.getInputStream();
          while(!shouldclose){
           if((retval=proc_stdout.read(buffer))==-1)  return;
	   	   
           if(retval>0) printBuffer(System.out,new String(buffer,0,retval));
           if((retval=proc_stderr.read(buffer))==-1) return;
           if(retval>0) printBuffer(System.err,new String(buffer,0,retval));
	   try{
		 sleep(100);
	   }catch(InterruptedException e){
	   }
      	  };
        }catch(IOException e){ 
          e.printStackTrace(System.out);
          return;
        }        
      } 
};      
                                    
