/*  File:     cnctStart.java 
    Project:  OOPracktikum 2001
	            Connect-Game Info Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoConfig
    Autor:    Georg Martius
    Descript: Startet Client
		
	create:
	date
	Mon Jun  6 16:08:31 MET DST 2001
		
    last mod: 
	date 
  Mon Jun  6 22:19:46 CEST 2001
*/

package cnctInfoConfig;

import java.io.*;
import java.util.Vector;
import cnctParser.*;

//import cnctClient;

public class cnctStart{
	///////////////// MEMBER /////////////////////////////
    private File clientInfoFile;
    private Vector clients;
    private String host;
    private int port;

	///////////////// DEKLARATIONEN /////////////////////////////

	
	///////////////// DEFINITIONEN /////////////////////////////

	//-----------------------------------------------------------------------
	public cnctStart(){
      clients= new Vector();
    }
    
	public Vector getClients(){
	  if(clients.size()==0) return null;
	  return clients;
	}
	
	//-----------------------------------------------------------------------
    public boolean executeClient(int num, String newPlayername){

      if(clients.size()>num && num>=1){
        return ((cnctClient)clients.elementAt(num-1)).execute(host, port, newPlayername);
      }
      return false;
    }    

	//-----------------------------------------------------------------------
    public boolean loadInfoConfig(String fileName){
      String line;
      FileReader fReader;
      LineNumberReader lReader;
      parser lineParser=new parser();
      knoten syntaxBaum;
      cnctClient client;

	  
      try{
        clientInfoFile= new File(fileName);
        fReader = new FileReader(clientInfoFile);
        lReader = new LineNumberReader(fReader);
      }catch(FileNotFoundException e){
        e.printStackTrace(System.out);
        return false;
      }
      try{        
        while(true){
          line=lReader.readLine();
          if(line==null) break;
          lineParser.baueBaum(line);
          syntaxBaum=lineParser.getSyntaxBaum();
          if(syntaxBaum.getTyp()==knoten.KONSTRUKTOR){
            if(syntaxBaum.compareName("Client")){  ///////// CLIENT
              client=new cnctClient();
              if (!client.extractData(syntaxBaum.getKind(0))){
                System.out.println("cnctStart::loadClientConfig: kann Clientdaten nicht extrahieren: " + line);
              }else{
                clients.addElement(client);              
              }
            }else
            if(syntaxBaum.compareName("Net")){  //////// NET
              extractNetData(syntaxBaum.getKind(0));
            }
            
          } 
        }
        
      }catch(IOException e){
        e.printStackTrace(System.out);
        return false;
      }
      return true;
    }
    
   private boolean extractNetData(knoten baum){
     knoten subknoten;
     int i;
     if (baum.getTyp() ==  knoten.RECORD){
        for(i=0;i<baum.getKinderZahl(); i++){
           if( (subknoten=baum.getKind(i))==null) continue;;
           if(subknoten.compareName("Host")){
             host=subknoten.getKind(0).getName();
           }else
           if(subknoten.compareName("Port")){
             port=subknoten.getKind(0).getZahl();
           }
        }
     }else return false;
     return true;                                                                                                                                                                                    
   }
    
   public static void main(String argv[]){
     cnctStart myself=new cnctStart();
   }    

}
