/*  File:     lineSocket.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoSocket
    Autor:    
    Descript: Klasse zum schreiben und lesen auf einem Socket (Zeilenbasiert)
    last mod: Mon Apr 30 23:28:27 CEST 2001
*/

package cnctInfoSocket;

import java.io.*;
import java.net.*;

class lineSocket extends Thread{
    //member
    private String hostname;
    private int port;
    private boolean isinit;
    
    //member fuer interne Benutzung
    //--------------------------------------------------    
    private Socket sock;
    private BufferedReader sockin;
    private PrintWriter sockout;
    
    
    /////////////////////////////////////////// F U N K T I O N E N ///////////////////////////
    // ###oeffnet Socket
    // public int open(String _hostname, int _port);
    // ###liest eine Zeile vom Socket
    // public String read();
    // ###Schreibt eine Zeile in den Socket
    // public void send(String tosend);
    // ###schliesst den Socket
    // public void close();
    // public String getHostName();
    // public int getPort();
    // public boolean isInit();
   
   
   /////////////////////////////////////////// I M P L E M E N T I E R U N G ///////////////////////////

    // Default Konstruktor
    //--------------------------------------------------    
    lineSocket(){
      super();
      isinit=false;
    }
    // Konstruktor fuer Initialisierung mit Werten 
    //--------------------------------------------------    
    lineSocket( String _hostname, int _port) throws cnctSocketException{
        super();
        isinit=false;
   	    open(_hostname, _port);
    }
    
    // oeffnet Socket
    // Param: 	hostname 	-> Name des Hosts
    //		port		-> Port sollte >1025
    // Return:	0 -> Fehler; 1-> OK
    public int open(String _hostname, int _port) throws cnctSocketException {
              hostname= _hostname;
	      port= _port;

	      if(isinit) close();

	      try{
	         sock= new Socket(hostname, port);
                 System.out.println("Client gebunden an lokalen Port:" + sock.getLocalPort());
                 sock.setSoTimeout(0);
                 sockin = new BufferedReader(new InputStreamReader(sock.getInputStream()));
                 sockout = new PrintWriter( sock.getOutputStream(), true);              sockout = new PrintWriter( sock.getOutputStream(), true);   
	      }catch (UnknownHostException ux){
	          throw new cnctSocketException("Host:" +  hostname + "ist dem DNS nicht bekannt.");
	      }catch (IOException ioe){
	          //ioe.printStackTrace();
		  throw new cnctSocketException("IOException");
	      }
	      isinit=true;
	      return 1;
    }

    // schliesst den Socket
    //--------------------------------------------------    
    public void close(){
      try{
          sock.close();
      }catch(IOException ioe){
	    // ioe.printStackTrace();
    	    System.out.println("lineSocket::close: IOException");        
      }
    }
        
    // Schreibt eine Zeile in den Socket
    //--------------------------------------------------    
    public void send(String tosend){
      //!!! exception auslsen
      if(isinit==false) return;
      
   /*  PATCH BY WALDMANN
   	 try{
        PrintWriter sockout = new PrintWriter(sock.getOutputStream(),true);      
        sockout.println(tosend);
       }
       catch (IOException ioe){
         ioe.printStackTrace();
      	 System.out.println("lineSocket::read: IOExecption");
       }
//       catch (InterruptedIOException iioe){ //keine Ausgabe bei Timeout
//      }*/

      System.out.println("<< " + tosend);
      sockout.println(tosend);       
    }
    
   // liest eine Zeile vom Socket
   // Return: gelesener String; Nullstring bei Fehler
   //--------------------------------------------------
    public String read(){
	    String reader="";
      
      //!!! exception auslsen
      if(isinit==false) return null;
 /*     
	    try{
              BufferedReader sockin=new BufferedReader(new InputStreamReader(sock.getInputStream()) );
	    }catch(IOException ioe){
	        ioe.printStackTrace();
	        System.out.println("lineSocket::close: IOException");        
	    }
      */
      try{
    	    return sockin.readLine();
      }catch(InterruptedIOException e){
//          System.out.println("lineSocket::read: " + e.toString());
      }catch(IOException ioe){
	        ioe.printStackTrace();
	        System.out.println("lineSocket::close: IOException");        	
	    }
	
    	return null;
    }
    
   //--------------------------------------------------    
   public String getHostName(){
     return hostname;
   }
   
   //--------------------------------------------------    
   public int getPort(){
     return port;
   }
   
   //--------------------------------------------------    
   public boolean isInit(){
     return isinit;
   }
   
}
